#include <sta/os2/system_event.hpp>

#ifdef STA_OS2_SYSTEM_EVENT_ENABLE

#include <cmsis_os2.h>


#ifndef STA_OS2_SYSTEM_EVENT_HANDLE
#  define STA_OS2_SYSTEM_EVENT_HANDLE systemEventHandle
#endif // !STA_OS2_SYSTEM_EVENT_HANDLE

// Access handle from freertos.c
extern osEventFlagsId_t STA_OS2_SYSTEM_EVENT_HANDLE;


namespace sta
{
	void signalSystemEvents(uint32_t flags)
	{
		osEventFlagsSet(STA_OS2_SYSTEM_EVENT_HANDLE, flags);
	}
	
	void waitForSystemEvents(uint32_t flags, uint32_t options, uint32_t timeout)
	{
		osEventFlagsWait(STA_OS2_SYSTEM_EVENT_HANDLE, flags, options | osFlagsNoClear, timeout);
	}
	
	
	void signalStartupEvent()
	{
		signalSystemEvents(STA_SYSTEM_EVENT_STARTUP);
	}

	void waitForStartupEvent()
	{
		waitForSystemEvents(STA_SYSTEM_EVENT_STARTUP, osFlagsWaitAll, osWaitForever);
	}
} // namespace sta


#endif // STA_SYSTEM_EVENT_ENABLE
