#include <sta/os2/watchdog.hpp>

#ifdef STA_OS2_WATCHDOG_ENABLE

#include <cmsis_os2.h>


#ifndef STA_OS2_WATCHDOG_TIMER_PERIOD
#  define STA_OS2_WATCHDOG_TIMER_PERIOD 1000
#endif // !STA_OS2_WATCHDOG_TIMER_PERIOD

#ifndef STA_OS2_WATCHDOG_TIMER_HANDLE
#  define STA_OS2_WATCHDOG_TIMER_HANDLE heartbeatHandle
#endif // !STA_OS2_WATCHDOG_TIMER_HANDLE

#ifndef STA_OS2_WATCHDOG_TIMER_CALLBACK
#  define STA_OS2_WATCHDOG_TIMER_CALLBACK heartbeatCallback
#endif // !STA_OS2_WATCHDOG_TIMER_CALLBACK


// Access handles from freertos.c
extern osTimerId_t STA_OS2_WATCHDOG_TIMER_HANDLE;


namespace sta
{
	void startWatchdogTimer()
	{
		osTimerStart(STA_OS2_WATCHDOG_TIMER_HANDLE, STA_OS2_WATCHDOG_TIMER_PERIOD);
	}
} // namespace sta


// Declare with C linkage
extern "C"
{
	void STA_OS2_WATCHDOG_TIMER_CALLBACK(void *)
	{
		// Notify watchdog task to send heartbeat message
		// Required because blocking in a timer callback is not allowed
		sta::notifyWatchdog(STA_WATCHDOG_FLAG_HEARTBEAT);
	}
}


#endif // STA_OS2_WATCHDOG_ENABLE
